/**
 * @file
 * VuoList_VuoCountWrapMode C type definition.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#ifndef VuoList_VuoCountWrapMode_H
#define VuoList_VuoCountWrapMode_H

/**
 * @ingroup VuoTypes
 * @defgroup VuoList_VuoCountWrapMode VuoList_VuoCountWrapMode
 * A list of @ref VuoCountWrapMode elements.
 *
 * @{
 */

// This header is generated by vuo/type/list/generateVariants.sh.

/**
 * @typedef VuoList_VuoCountWrapMode
 * A list of @ref VuoCountWrapMode elements.
 */
#ifndef VuoList_VuoCountWrapMode_TYPE_DEFINED
typedef void * VuoList_VuoCountWrapMode;
#endif

/**
 * Creates a new list of @ref VuoCountWrapMode elements.
 */
VuoList_VuoCountWrapMode VuoListCreate_VuoCountWrapMode(void);

/**
 * Returns the @ref VuoCountWrapMode at @c index.
 * Index values start at 1.
 * If the list has no items, returns a default value.
 * Attempting to access an out-of-bounds index returns the first item in the list (if the index is 0), or last item in the list (if the index is greater than the list size).
 */
VuoCountWrapMode VuoListGetValueAtIndex_VuoCountWrapMode(const VuoList_VuoCountWrapMode list, const unsigned long index);

/**
 * Appends @c value to @c list.
 */
void VuoListAppendValue_VuoCountWrapMode(VuoList_VuoCountWrapMode list, const VuoCountWrapMode value);

/**
 * Removes the last value from @c list.
 */
void VuoListRemoveLastValue_VuoCountWrapMode(VuoList_VuoCountWrapMode list);

/**
 * Removes all values from @c list.
 */
void VuoListRemoveAll_VuoCountWrapMode(VuoList_VuoCountWrapMode list);

/**
 * Returns the number of elements in @c list.
 */
unsigned long VuoListGetCount_VuoCountWrapMode(const VuoList_VuoCountWrapMode list);

/**
 * Decodes the JSON object @c js to create a new value.
 *
 * @eg{
 *	["uno", "dos", "tres", "catorce"]
 * }
 */
VuoList_VuoCountWrapMode VuoList_VuoCountWrapMode_valueFromJson(struct json_object * js);

/**
 * Encodes @c value as a JSON object.
 */
struct json_object * VuoList_VuoCountWrapMode_jsonFromValue(const VuoList_VuoCountWrapMode value);

/**
 * Produces a brief human-readable summary of @c value.
 */
char * VuoList_VuoCountWrapMode_summaryFromValue(const VuoList_VuoCountWrapMode value);

/// @{
/**
 * Automatically generated function.
 */
VuoList_VuoCountWrapMode VuoList_VuoCountWrapMode_valueFromString(const char *str);
char * VuoList_VuoCountWrapMode_stringFromValue(const VuoList_VuoCountWrapMode value);
/// @}

/**
 * @}
 */

#endif
